# You have to combine (using rbind) the binary matrices and save it as "combined.chr1.RData"
filenames <- dir()
filenames <- filenames[grep(".chr1.RData", filenames)]
cell.type.names <- sub(".chr1.RData$", '', filenames)
binary.matrices <- list()
chromosome <- "chr1"
for (cell.type in cell.type.names) {
  csre <- read.table(paste(cell.type, "CSRE", sep = "."), header = FALSE, as.is = TRUE)
  csre <- cbind(csre, array(0, dim = c(nrow(csre), 1)))
  load(paste("hamming", chromosome, "RData", sep = "."))
  rownames(hamming) <- cell.type.names
  idx <- which(csre[, 1] == chromosome)
  if (length(idx) == 0) {
    next
  }
  load(paste("combined", chromosome, "RData", sep = "."))
  for (idx.now in idx) {
    csre.start <- csre[idx.now, 2]
    csre.end <- csre[idx.now, 3]
    data.obs <- apply(combined.binary[, csre.start:csre.end], 1, sum)
    data.prob <- array(0, dim = c(10, 1))
    for (iter in c(1:10)) {
      data.prob[iter] <-
        sum(data.obs[seq(from = iter, by = 10, length.out = 9)])/(9*csre[idx.now, 4])
    }
    null <- c()
    for (n.sim in c(1:111)){
      data.null <- array(0, dim = c(90, csre[idx.now, 4]))
      for (iter in c(1:10)) {
        for (row.idx in seq(from = iter, by = 10, length.out = 9)) {
          data.null[row.idx, ] <- rbinom(csre[idx.now, 4], size = 1, prob = data.prob[iter])
        }
      }
      hamming.null <- array(0, dim = c(9, 1))
      for (i in c(1:8)) {
        for (j in c((i + 1):9)) {
		      temp <- sum(apply(data.null[(i*10 - 9):(i*10), ] != data.null[(j*10 - 9):(j*10), ], 2, sum))
          hamming.null[i] <- hamming.null[i] + temp
          hamming.null[j] <- hamming.null[j] + temp
        }
      }
        null <- c(null, hamming.null)
    }
    csre[idx.now, 5] <- 
	    pnorm(sum(hamming[cell.type, csre.start:csre.end]), mean = mean(null), sd = sd(null), lower.tail = FALSE)
  }
  write.table(csre, file = 
    paste(cell.type, "pvalue", sep = "."), quote = FALSE, sep = " ", col.names = FALSE, row.names = FALSE)
}